diff --git a/cdist/conf/type/__keyboard/man.rst b/cdist/conf/type/__keyboard/man.rst
new file mode 100644
index 00000000..0eb4cde9
--- /dev/null
+++ b/cdist/conf/type/__keyboard/man.rst
@@ -0,0 +1,37 @@
+cdist-type__keyboard(7)
+=======================
+
+NAME
+----
+cdit-type__keyboard - Set keyboard layout
+
+
+DESCRIPTION
+-----------
+This cdist type allows you to modify keyboard layout.
+
+
+REQUIRED PARAMETERS
+-------------------
+type
+   Any valid type, for example "us"
+
+
+EXAMPLES
+--------
+
+.. code-block:: sh
+
+    # Set keyboard type to "us"
+    __keyboard --type "us"
+
+
+AUTHORS
+-------
+Carlos Ortigoza <carlos.ortigoza--@--ungleich.ch>
+
+
+COPYING
+-------
+Copyright \(C) 2016 Carlos Ortigoza. Free use of this software is
+granted under the terms of the GNU General Public License v3 or later (GPLv3+).
diff --git a/cdist/conf/type/__keyboard/manifest b/cdist/conf/type/__keyboard/manifest
new file mode 100644
index 00000000..3bfddf0b
--- /dev/null
+++ b/cdist/conf/type/__keyboard/manifest
@@ -0,0 +1,50 @@
+#!/bin/sh
+#
+# Carlos Ortigoza (carlos.ortigoza at ungleich.ch)
+#
+# This file is part of cdist.
+#
+# cdist is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# cdist is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with cdist. If not, see <http://www.gnu.org/licenses/>.
+#
+#
+# Configure keyboard type by modifying /etc/sysconfig/keyboard file.
+#
+
+os=$(cat "$__global/explorer/os")
+keyboard_type="$(cat "$__object/parameter/type")"
+
+case "$os" in
+    centos)
+        __file /etc/sysconfig/keyboard \
+            --owner root --group root --mode 644 \
+            --state exists
+
+        require="__file/etc/sysconfig/keyboard" \
+            __key_value KEYTABLE \
+                --file /etc/sysconfig/keyboard \
+                --delimiter '=' \
+                --value "\"$keyboard_type\""
+        
+        require="__file/etc/sysconfig/keyboard" \
+            __key_value LAYOUT \
+                --file /etc/sysconfig/keyboard \
+                --delimiter '=' \
+                --value "\"$keyboard_type\""
+    ;;
+    *)
+      echo "Your operating system ($os) is currently not supported by this type (${__type##*/})." >&2
+      echo "Please contribute an implementation for it if you can." >&2
+      exit 1
+    ;;
+esac
diff --git a/cdist/conf/type/__keyboard/parameter/required b/cdist/conf/type/__keyboard/parameter/required
new file mode 100644
index 00000000..aa80e646
--- /dev/null
+++ b/cdist/conf/type/__keyboard/parameter/required
@@ -0,0 +1 @@
+type
diff --git a/cdist/conf/type/__keyboard/singleton b/cdist/conf/type/__keyboard/singleton
new file mode 100644
index 00000000..e69de29b
diff --git a/docs/changelog b/docs/changelog
index 06ebeaa3..d836af52 100644
--- a/docs/changelog
+++ b/docs/changelog
@@ -2,6 +2,7 @@ Changelog
 ---------
 next:
 	* Core: Add derived env vars for target hostname and fqdn (Darko Poljak)
+	* New type: __keyboard: Set keyboard layout (Carlos Ortigoza)
 	* Documentation: Re-license types' man pages to GPLV3+ (Dmitry Bogatov,	Darko Poljak)
 	* New type __filesystem: manage filesystems on devices (Daniel Heule)
 	* New type: __locale_system (Steven Armstrong, Carlos Ortigoza, Nico Schottelius)